<!---终端入网检测-->
<template>
    <TableHeader area datePicker nextFlag theCurrentTime showTimeAll showExport ref="TableHeaderRef" showCustomColumn>
        <template #select>
            <el-form-item label="搜索">
                <el-input v-model="tableStore.table.params.searchValue" placeholder="输入变电站、终端、监测点名称"
                    clearable style="width: 250px" maxlength="32" show-word-limit></el-input>
            </el-form-item>
            <el-form-item label="流程状态">
                <el-select v-model="tableStore.table.params.status" clearable placeholder="请选择流程状态" filterable>
                    <el-option v-for="item in statusSelect" :key="item.id" :label="item.name"
                        :value="item.id"></el-option>
                </el-select>
            </el-form-item>
        </template>
        <template #operation>
            <el-button icon="el-icon-Delete" type="primary" @click="deleteEven">删除</el-button>
            <!-- <el-button icon="el-icon-Plus" type="primary" @click="addFormModel">新增</el-button> -->
            <!-- <el-button icon="el-icon-Download" @click="exportEvent" type="primary">导出</el-button> -->
        </template>
    </TableHeader>
    <Table ref="tableRef" :checkbox-config="checkboxConfig" />
    <!-- 申请联调弹框 -->
    <debug ref="debugForms" @onSubmit="tableStore.index()" :debugId="debugId"></debug>
</template>
<script setup lang="ts">
import { ref, onMounted, provide, watch } from 'vue'
import TableStore from '@/utils/tableStore'
import { ElMessage, ElMessageBox } from 'element-plus'
import Table from '@/components/table/index.vue'
import TableHeader from '@/components/table/header/index.vue'
import { useRouter } from 'vue-router'
import { useDictData } from '@/stores/dictData'
import { getLoadTypeUserList } from '@/api/process-boot/interference'
import {
    getMointorPointTempLinedebugDetail,
    setTempLinedebugLedgerSync
} from '@/api/supervision-boot/jointDebugList/index'
import debug from './debug.vue'
import { cancelMointorPointTempLinedebug } from '@/api/supervision-boot/jointDebugList/index'
import { useAdminInfo } from '@/stores/adminInfo'
import { deleteTempLineDebugReport } from '@/api/supervision-boot/delete/index'
//获取登陆用户姓名和部门
const adminInfo = useAdminInfo()
const dictData = useDictData()
const { push, options, currentRoute } = useRouter()
const flag = ref(false)
const TableHeaderRef = ref()
const tableRef = ref()
const statusSelect = dictData.statusSelect()
statusSelect.push({ name: '同步台账成功', id: 5 })
const tableStore = new TableStore({
    url: '/supervision-boot/tempLinedebug/list',
    publicHeight: 65,
    method: 'POST',
    filename:'监测点联调列表',
    column: [
        {
            width: '60',
            type: 'checkbox'
        },
        { title: '序号',  width: 80,formatter: (row: any) => {
        return (tableStore.table.params.pageNum - 1) * tableStore.table.params.pageSize + row.rowIndex + 1
      } },
        {
            field: 'powerSubstationName',
            title: '电网侧变电站',
            minWidth: 170,
            formatter: (row: any) => {
                return row.cellValue ? row.cellValue : '/'
            }
        },
        { field: 'lineName', title: '监测点名称', minWidth: 170 },
        {
            field: 'reason',
            title: '调试原因',
            minWidth: 170,
            formatter: (row: any) => {
                return row.cellValue ? row.cellValue : '/'
            }
        },
        { field: 'lineId', title: '监测点编号', minWidth: 170 },
        // { field: 'monitoringTerminalCode', title: '终端编码', minWidth: 170 },
        { field: 'monitoringTerminalName', title: '终端名称', minWidth: 170 },
        {
            field: 'createBy',
            title: '填报人',
            minWidth: 80,
            formatter: (row: any) => {
                return dictData.state.userList.filter(item => item.id == row.cellValue)[0]?.name
            }
        },
        {
            field: 'status',
            title: '流程状态',
            minWidth: 100,
            render: 'tag',
            custom: {
                0: 'warning',
                1: 'primary',
                2: 'success',
                3: 'danger',
                4: 'warning',
                5: 'primary'
            },
            replaceValue: {
                0: '待提交审批',
                1: '审批中',
                2: '审批通过',
                3: '审批不通过',
                4: '已取消',
                5: '同步台账成功',
                null: '/'
            }
        },
        {
             title: '操作',fixed: 'right',
            minWidth: 150,
     
            render: 'buttons',
            buttons: [
                {
                    name: 'productSetting',
                    title: '流程详情',
                    type: 'primary',
                    icon: 'el-icon-EditPen',
                    render: 'basicButton',
                    click: row => {
                        flag.value = true
                        handleAudit(row.processInstanceId, row.historyInstanceId)
                    },
                    disabled: row => {
                        return !row.processInstanceId
                    }
                },
                // {
                //     name: 'edit',
                //     title: '编辑',
                //     type: 'primary',
                //     icon: 'el-icon-Open',
                //     render: 'basicButton',
                //     showDisabled: row => {
                //         return row.createBy != adminInfo.$state.id || !(row.status == 0)
                //     },
                //     disabled: row => {
                //         return !(row.status == 0)
                //     },
                //     click: row => {
                //         debugForms.value.open('编辑', row)
                //     }
                // },
                {
                    name: 'productSetting',
                    title: '申请联调',
                    type: 'primary',
                    icon: 'el-icon-add',
                    render: 'basicButton',
                    click: row => {
                        // handleDebug(row)
                        debugForms.value.open('申请联调', row)
                    },
                    disabled: row => {
                        return row.reason
                    }
                },

                {
                    name: 'edit',
                    title: '重新发起',
                    type: 'warning',
                    icon: 'el-icon-Open',
                    render: 'basicButton',
                    disabled: row => {
                        return row.createBy != adminInfo.$state.id || !(row.status == 3 || row.status == 4)
                    },
                    click: row => {
                        debugForms.value.open('重新发起', row)
                    }
                },
                {
                    name: 'cancel',
                    title: '取消',
                    type: 'danger',
                    icon: 'el-icon-Open',
                    render: 'basicButton',
                    disabled: row => {
                        return row.createBy != adminInfo.$state.id || row.status != 1
                    },
                    click: row => {
                        cancelLeave(row)
                    }
                },
                {
                    name: 'productSetting',
                    title: '同步台账',
                    type: 'primary',
                    icon: 'el-icon-add',
                    render: 'basicButton',
                    click: row => {
                        setTempLinedebugLedgerSync({ id: row.id }).then(res => {
                            if (res.code == 'A0000') {
                                ElMessage({
                                    message: '台账同步成功',
                                    type: 'success'
                                })
                                tableStore.index()
                            }
                        })
                    },
                    disabled: row => {
                        return row.status != 2
                    }
                }
            ]
        }
    ],

    beforeSearchFun: () => {
        tableStore.table.params.orgNo = tableStore.table.params.deptIndex
        tableStore.table.params.statveList = [2]
        // tableStore.table.params.relationUserName = tableStore.table.params.userName
    },
    exportProcessingData: () => {
        tableStore.table.allData = tableStore.table.allData.filter(item => {
            item.status =
                item.status == 0
                    ? '待提交审批'
                    : item.status == 1
                    ? '审批中'
                    : item.status == 2
                    ? '审批通过'
                    : item.status == 3
                    ? '审批不通过'
                    : item.status == 4
                    ? '已取消':item.status == 5
                    ? '同步台账成功':'/'
            return item
        })
    }
})
tableStore.table.params.status = ''
tableStore.table.params.searchValue = ''
// tableStore.table.params.loadType = ''
// tableStore.table.params.userName = ''
// tableStore.table.params.fileUploadflag = ''

provide('tableStore', tableStore)

const exportEvent = () => {
    let form = JSON.parse(JSON.stringify(tableStore.table.params))
    form.pageNum = 1
    form.pageSize = tableStore.table.total
    getLoadTypeUserList(form).then(res => {
        tableRef.value.getRef().exportData({
            filename: '未建档非线性用户', // 文件名字
            sheetName: 'Sheet1',
            type: 'xlsx', //导出文件类型 xlsx 和 csv
            useStyle: true,
            data: res.data.records, // 数据源 // 过滤那个字段导出
            columnFilterMethod: function (column: any) {
                return !(column.$columnIndex === 0)
            }
        })
    })
}
// 禁止点击
const checkboxConfig = reactive({
    checkMethod: ({ row }) => {
        return adminInfo.roleCode.includes('delete_info')
            ? true
            : row.createBy == adminInfo.$state.id && row.status == 0
    }
})
const deleteEven = () => {
    if (tableStore.table.selection.length == 0) {
        ElMessage({
            type: 'warning',
            message: '请选择要删除的数据'
        })
    } else {

        ElMessageBox.confirm('此操作将永久删除, 是否继续?', '提示', {
            confirmButtonText: '确定',
            cancelButtonText: '取消',
            type: 'warning'
        })
            .then(() => {

                deleteTempLineDebugReport(tableStore.table.selection.map(item => item.id)).then(res => {
                    ElMessage({
                        type: 'success',
                        message: '删除成功!'
                    })
                    tableStore.index()
                })

            })
    }
}
onMounted(() => {
    tableStore.index()
})

/** 处理审批按钮 */
const handleAudit = (instanceId: any, historyInstanceId: any) => {
    push({
        name: 'BpmProcessInstanceDetail',
        state: {
            id: instanceId,
            historyInstanceId
        }
    })
}
//申请联调
const debugForms = ref()
const debugId = ref('')
const handleDebug = (row: any) => {
    debugId.value = row.id
    console.log(debugId.value)
    debugForms.value.open('申请联调', row)
}
/**取消流程操作*/
const cancelLeave = async (row: any) => {
    // 二次确认
    const { value } = await ElMessageBox.prompt('请输入取消原因', '取消流程', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        inputType: 'textarea',
        inputPattern: /^[\s\S]*.*\S[\s\S]*$/, // 判断非空，且非空格
        inputErrorMessage: '取消原因不能为空'
    })
    // 发起取消
    let data = {
        id: row.id,
        processInstanceId: row.processInstanceId,
        reason: value
    }
    await cancelMointorPointTempLinedebug(data)
    ElMessage.success('取消成功')
    // 加载数据
    tableStore.index()
}
watch(
    () => currentRoute.value.path,
    () => {
        if (flag.value && options.history.state.forward?.split('/')[1] == 'bpm') {
            tableStore.index()
            flag.value = false
        }
    },
    {
        deep: true
    }
)

const props = defineProps({ id: { type: String, default: 'null' } })
watch(() => props.id, async (newValue, oldValue) => {
    if (newValue === 'null') return // 直接返回，避免后续逻辑执行
    const fullId = newValue.split('@')[0]
    let nowTime = Date.now()
    const routeTime = Number(newValue.split('@')[1])
    if (isNaN(routeTime) || nowTime - routeTime > import.meta.env.VITE_ROUTE_TIME_OUT) return // 路由时间超过500ms，则不执行
    await getMointorPointTempLinedebugDetail({ id: fullId }).then(res => {
        if (res && res.code == 'A0000') {
            debugForms.value.open('重新发起', res.data)
        }
    })
}, { immediate: true })
</script>

<style scoped lang="scss">
:deep(.el-upload-list__item) {
    width: 400px;
}

::v-deep .el-input__wrapper {
    // width: 200px !important;
}
</style>
